-- Pixie code by j2b2

-- BUG: When a player with MF_NOGRAVITY gets instantly crushed by horizontal moving walls

-- Cache globals
local L_BT_JUMP = BT_JUMP
local L_BT_SPIN = BT_SPIN
local L_CR_MINECART = CR_MINECART
local L_CR_ROLLOUT = CR_ROLLOUT
local L_FF_EXISTS = FF_EXISTS
local L_FF_BUSTUP = FF_BUSTUP
local L_MF_NOGRAVITY = MF_NOGRAVITY
local L_MF2_NIGHTSPULL = MF2_NIGHTSPULL
local L_MF2_TWOD = MF2_TWOD
local L_MF2_OBJECTFLIP = MF2_OBJECTFLIP
local L_PF_APPLYAUTOBRAKE = PF_APPLYAUTOBRAKE
local L_PF_DRILLING = PF_DRILLING
local L_PST_DEAD = PST_DEAD
local L_S_LOCKON1 = S_LOCKON1
local L_S_PLAY_WAIT = S_PLAY_WAIT
local L_S_PLAY_FALL = S_PLAY_FALL
local L_S_PLAY_GASP = S_PLAY_GASP
local L_S_PLAY_ROLL = S_PLAY_ROLL
local L_S_PLAY_RUN = S_PLAY_RUN
local L_S_PLAY_SPRING = S_PLAY_SPRING
local L_S_PLAY_STND = S_PLAY_STND
local L_S_PLAY_WALK = S_PLAY_WALK
local L_SH_NONE = SH_NONE
local L_SH_PROTECTELECTRIC = SH_PROTECTELECTRIC
local L_V_HUDTRANS = V_HUDTRANS
local L_V_HUDTRANSHALF = V_HUDTRANSHALF
local L_V_PERPLAYER = V_PERPLAYER
local L_V_SNAPTOBOTTOM = V_SNAPTOBOTTOM
local L_V_SNAPTOLEFT = V_SNAPTOLEFT
local L_V_SNAPTORIGHT = V_SNAPTORIGHT
local L_V_YELLOWMAP = V_YELLOWMAP
local l_pw_carry = pw_carry
local l_pw_ignorelatch = pw_ignorelatch
local l_pw_nocontrol = pw_nocontrol
local l_pw_shield = pw_shield
local l_pw_super = pw_super

local L_FixedDiv = FixedDiv
local L_FixedMul = FixedMul
local L_FixedHypot = FixedHypot
local L_P_AproxDistance = P_AproxDistance
local L_P_ReturnThrustX = P_ReturnThrustX
local L_P_ReturnThrustY = P_ReturnThrustY
local L_R_PointToAngle2 = R_PointToAngle2

local AIR_FRICTION_AUTOBRAKE = L_FixedDiv(29 * FRACUNIT,30 * FRACUNIT)
local AIR_FRICTION = L_FixedMul(AIR_FRICTION_AUTOBRAKE, AIR_FRICTION_AUTOBRAKE)
local ADD_MOMZ = FRACUNIT
local ATTRACT_DIST = 96 * FRACUNIT
local CHAR_LEFT_ARROW = string.char(28)
local CHAR_RIGHT_ARROW = string.char(29)
local DASH_SPEED = 35 * FRACUNIT
local DIST_PARTNER_SELECT = 600 * FRACUNIT
local FOLLOW_ANGLE_1 = ANGLE_225
local FOLLOW_ANGLE_2 = ANGLE_135
local FOLLOW_ANGLE_3 = FOLLOW_ANGLE_1 - ANGLE_22h
local FOLLOW_ANGLE_4 = FOLLOW_ANGLE_2 + ANGLE_22h
local FOLLOW_DIST = 60 * FRACUNIT
local FOLLOW_DIST_2D = 40 * FRACUNIT
local FOLLOW_HEIGHT = L_FixedDiv(3 * FRACUNIT, 4 * FRACUNIT)
local FOLLOW_MAXSPEED = 300 * FRACUNIT
local FOLLOW_TELEPORT_DIST = 200 * FRACUNIT
local GIVE_COOLDOWN = TICRATE / 2
local GIVE_DIST = 300 * FRACUNIT
local GIVE_RINGS = 10
local HOMING_INVULN = TICRATE / 4
local SOUND_GIVE_RING = sfx_itemup
local SOUND_NO_GOOD = sfx_kc43
local SOUND_SHIELD_STORE = sfx_3db09
local SOUND_SUCCESS = sfx_s3ka7
local STOP_MOMENTUM = L_FixedDiv(FRACUNIT, FRACUNIT*10)

local cvPixieOverwrite = CV_RegisterVar({name="pixie_overwrite", defaultvalue=1, flags=CV_NETVAR | CV_SHOWMODIF, PossibleValue={No = 0, Yes = 1}})

if not (kirbyabilitytable) then
	rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["pixie"] = 16

local function IsValid(a)
	if a ~= nil then return a.valid end
	return false
end

local Old_A_GiveShield = A_GiveShield

function A_GiveShield(actor, var1, var2)
	local playerMo = actor.target
	if playerMo.skin == "pixie" then
		local player = playerMo.player
		player.pixiePowerup = actor.type
		S_StartSound(playerMo, SOUND_SHIELD_STORE)
		return
	end
	Old_A_GiveShield(actor, var1, var2)
end

local Old_A_GravityBox = A_GravityBox

function A_GravityBox(actor, var1, var2)
	local playerMo = actor.target
	if playerMo.skin == "pixie" then
		local player = playerMo.player
		player.pixiePowerup = actor.type
		S_StartSound(playerMo, SOUND_SHIELD_STORE)
		return
	end
	Old_A_GravityBox(actor, var1, var2)
end

local Old_A_Invincibility = A_Invincibility

function A_Invincibility(actor, var1, var2)
	local playerMo = actor.target
	if playerMo.skin == "pixie" then
		local player = playerMo.player
		player.pixiePowerup = actor.type
		S_StartSound(playerMo, SOUND_SHIELD_STORE)
		return
	end
	Old_A_Invincibility(actor, var1, var2)
end

local Old_A_SuperSneakers = A_SuperSneakers

function A_SuperSneakers(actor, var1, var2)
	local playerMo = actor.target
	if playerMo.skin == "pixie" then
		local player = playerMo.player
		player.pixiePowerup = actor.type
		S_StartSound(playerMo, SOUND_SHIELD_STORE)
		return
	end
	Old_A_SuperSneakers(actor, var1, var2)
end

local Old_A_AttractChase = A_AttractChase

function A_AttractChase(actor, ...)
	for player in players.iterate do
		local playerMo = player.mo
		if IsValid(playerMo)
		and playerMo.skin == "pixie"
		and not player.pixieFollow
		and player.powers[l_pw_shield] & L_SH_PROTECTELECTRIC == 0
		and actor.flags2 & L_MF2_NIGHTSPULL == 0
		and actor.health
		and P_CanPickupItem(player)
		and P_CheckSight(actor, playerMo) then

			local dx = playerMo.x - actor.x
			local dy = playerMo.y - actor.y
			local dz = (playerMo.z + playerMo.height / 2) - actor.z
			local xydist = L_P_AproxDistance(dx, dy)
			local dist = L_P_AproxDistance(xydist, dz)
			local ang = L_R_PointToAngle2(actor.x, actor.y, playerMo.x, playerMo.y);
			if dist >= 0 and dist < ATTRACT_DIST then
				local speedmul = L_P_AproxDistance(playerMo.momx, playerMo.momy) + L_FixedMul(actor.info.speed, actor.scale)
				actor.momx = L_FixedMul(L_FixedDiv(playerMo.x - actor.x, dist), speedmul);
				actor.momy = L_FixedMul(L_FixedDiv(playerMo.y - actor.y, dist), speedmul);
				actor.momz = L_FixedMul(L_FixedDiv(playerMo.z - actor.z, dist), speedmul);
				actor.tracer = playerMo
				return
			end
		end
	end
	Old_A_AttractChase(actor, ...)
end

local function CheckAndCrumble2(mo, sec)
	for fof in sec.ffloors() do
		if not (fof.flags & L_FF_EXISTS) then continue end -- Does it exist?
		if not (fof.flags & L_FF_BUSTUP) then continue end -- Is it bustable?

		if mo.z + mo.momz + mo.height < fof.bottomheight then continue end -- Are we too low?
		if mo.z + mo.momz > fof.topheight then continue end -- Are we too high?

		EV_CrumbleChain(fof) -- Crumble
	end
end

---@param player player_t
local function RemovePartner(player)
	local oldPartner = player.pixiePartner
	if oldPartner ~= nil and IsValid(oldPartner) and oldPartner.pixieFollowers ~= nil then
		local oldPartnerFollowers = oldPartner.pixieFollowers
		oldPartnerFollowers[player.pixiePartnerNum] = nil
		local remove = true
		for i = 1, 4 do
			local pixie = oldPartnerFollowers[i]
			if IsValid(pixie) then
				remove = false
			end
		end
		if remove then
			oldPartner.pixieFollowers = nil
		end
	end
	player.pixiePartner = nil
	player.pixiePartnerNum = nil
end

---@param player player_t
---@param newPartner player_t
local function SetPartner(player, newPartner)
	RemovePartner(player)
	local newPartnerFollowers = newPartner.pixieFollowers
	if newPartnerFollowers ~= nil then
		for i = 1, 4 do
			local pixie = newPartnerFollowers[i]
			if not IsValid(pixie) then
				player.pixiePartner = newPartner
				player.pixiePartnerNum = i
				newPartnerFollowers[i] = player
				return true
			end
		end
		return false
	else
		player.pixiePartner = newPartner
		player.pixiePartnerNum = 1
		newPartner.pixieFollowers = {player}
		return true
	end
end

---@param player player_t
---@param partner player_t
---@param partnerMo mobj_t
local function GetFollowPos(player, partner, partnerMo)
	local ang
	local partnerNum = player.pixiePartnerNum
	if partnerMo.flags2 & L_MF2_TWOD then
		local dist = FOLLOW_DIST_2D * partnerNum
		ang = partner.drawangle
		local x = partnerMo.x + L_P_ReturnThrustX(nil, ang, -dist)
		local y = partnerMo.y + L_P_ReturnThrustY(nil, ang, -dist)
		local z = partnerMo.z + L_FixedMul(partnerMo.height*P_MobjFlip(partnerMo), FOLLOW_HEIGHT)
		return x, y, z, ang
	else
		if partnerNum == 1 then
			ang = partner.drawangle + FOLLOW_ANGLE_1
		elseif partnerNum == 2 then
			ang = partner.drawangle + FOLLOW_ANGLE_2
		elseif partnerNum == 3 then
			ang = partner.drawangle + FOLLOW_ANGLE_3
		elseif partnerNum == 4 then
			ang = partner.drawangle + FOLLOW_ANGLE_4
		end

		local x = partnerMo.x + L_P_ReturnThrustX(nil, ang, FOLLOW_DIST)
		local y = partnerMo.y + L_P_ReturnThrustY(nil, ang, FOLLOW_DIST)
		local z = partnerMo.z + L_FixedMul(partnerMo.height*P_MobjFlip(partnerMo), FOLLOW_HEIGHT)
		return x, y , z, ang
	end
end

---@param player player_t
local function StopFollowing(player)
	if player.pixieFollow then
		player.pixieFollow = false
		player.powers[l_pw_ignorelatch] = 0
		return true
	end
	return false
end

---@param player player_t
local function StopHoming(player)
	local playerMo = player.mo
	player.pixieHoming = -HOMING_INVULN
	player.pflags = $ & ~L_PF_DRILLING
	playerMo.tracer = nil
end

---@class player_t
---@field pixieFollow boolean
---@field pixieGiveCooldown integer
---@field pixieHoming integer
---@field pixiePartner player_t?
---@field pixiePartnerNum integer
---@field pixiePowerup integer

---@class CharacterManager2.Character
local Character = {
	name = "pixie"
}

function Character.EquipSkin(player)
	player.pixieFollow = false
	player.pixieGiveCooldown = 0
	player.pixieHoming = 0
	player.pixiePartner = nil
	player.pixiePartnerNum = nil

	local playerMo = player.mo
	if not IsValid(playerMo) then return end
	playerMo.flags = $ | L_MF_NOGRAVITY
end

function Character.UnEquipSkin(player)
	RemovePartner(player)
	player.pixieFollow = nil
	player.pixieGiveCooldown = nil
	player.pixieHoming = nil
	player.pixiePartner = nil
	player.pixiePartnerNum = nil
	player.powers[l_pw_ignorelatch] = 0

	local playerMo = player.mo
	if IsValid(playerMo) and player.pixiePowerup then
		local icon = P_SpawnMobjFromMobj(player.mo, 0, 0, 0 * FRACUNIT, player.pixiePowerup)
		icon.target = playerMo
		icon.state = states[icon.state].nextstate
		icon.tics = 1
	end
	player.pixiePowerup = nil

	local playerMo = player.mo
	if not IsValid(playerMo) then return end
	playerMo.flags = $ & ~L_MF_NOGRAVITY
end

function Character.Spawn(player)
	local playerMo = player.mo
	if not IsValid(playerMo) then return end
	playerMo.flags = $ | L_MF_NOGRAVITY
end

function Character.Think(player)
	local playerMo = player.mo
	if not IsValid(playerMo) then return end
	local cmd = player.cmd

	local partner = player.pixiePartner
	local partnerMo
	if not IsValid(partner) or partner.quittime > 0 then
		StopFollowing(player)
		RemovePartner(player)
	else
		partnerMo = partner.mo
		if player.pixieFollow and (player.playerstate & L_PST_DEAD > 0 or not IsValid(partnerMo)) then
			StopFollowing(player)
		end
	end

	if player.pixieFollow then
		playerMo.flags2 = partnerMo.flags2 & (L_MF2_TWOD | L_MF2_OBJECTFLIP)
		player.powers[l_pw_ignorelatch] = 40000
		playerMo.scale = partnerMo.scale

		local followX, followY, followZ = GetFollowPos(player, partner, partnerMo)
		local distX = followX - playerMo.x
		local distY = followY - playerMo.y
		local distZ = followZ - playerMo.z
		local dist = L_FixedHypot(L_FixedHypot(distX, distY), distZ)
		if dist > FOLLOW_TELEPORT_DIST and not P_CheckSight(playerMo, partnerMo) then
			P_TeleportMove(playerMo, partnerMo.x, partnerMo.y, partnerMo.z)
			S_StartSound(playerMo, sfx_mixup)
			P_FlashPal(player, PAL_MIXUP, 10)
		else
			local speed = min(dist / 12, FOLLOW_MAXSPEED)
			local xDir = FixedDiv(distX, dist)
			local yDir = FixedDiv(distY, dist)
			local zDir = FixedDiv(distZ, dist)
			playerMo.momx = FixedMul(xDir, speed) + partnerMo.momx
			playerMo.momy = FixedMul(yDir, speed) + partnerMo.momy
			playerMo.momz = FixedMul(zDir, speed) + partnerMo.momz
			if dist < FRACUNIT*50 then
				player.drawangle = partner.drawangle
			else
				player.drawangle = L_R_PointToAngle2(0, 0, playerMo.momx, playerMo.momy)
			end
		end

		if player.pixieGiveCooldown == 0 then
			if dist < GIVE_DIST then
				if cmd.sidemove < -25 then
					if player.rings >= GIVE_RINGS then
						P_GivePlayerRings(player, -GIVE_RINGS)
						P_GivePlayerRings(player.pixiePartner, GIVE_RINGS)
						S_StartSound(partnerMo, SOUND_GIVE_RING)
					else
						S_StartSound(nil, SOUND_NO_GOOD, player)
					end
					player.pixieGiveCooldown = GIVE_COOLDOWN
				elseif cmd.sidemove > 25 then
					if player.pixiePowerup == nil or (player.pixiePartner.powers[l_pw_shield] ~= L_SH_NONE and cvPixieOverwrite.value == 0) then
						S_StartSound(nil, SOUND_NO_GOOD, player)
					else
						local icon = P_SpawnMobjFromMobj(playerMo, 0, 0, 0, player.pixiePowerup)
						icon.target = player.pixiePartner.mo
						icon.state = states[icon.state].nextstate
						icon.tics = 1
						player.pixiePowerup = nil
						playerMo.state = L_S_PLAY_GASP
						S_StartSound(playerMo, SOUND_SHIELD_STORE)
					end
					player.pixieGiveCooldown = GIVE_COOLDOWN
				end
			end
		else
			player.pixieGiveCooldown = $ - 1
		end
	elseif player.powers[l_pw_carry] == 0 then
		if P_PlayerInPain(player) or player.exiting ~= 0 then
			player.pixieHoming = 0
			player.pflags = $ & ~L_PF_DRILLING
			playerMo.flags = $ & ~L_MF_NOGRAVITY
		else
			playerMo.flags = $ | L_MF_NOGRAVITY
			if  cmd.buttons & L_BT_JUMP and (player.powers[l_pw_nocontrol] == 0 or player.powers[l_pw_nocontrol] >= 32768) then
				P_SetObjectMomZ(playerMo, ADD_MOMZ, true)
			elseif  cmd.buttons & L_BT_SPIN and player.powers[l_pw_nocontrol] == 0 then
				P_SetObjectMomZ(playerMo, -ADD_MOMZ, true)
			end
		end
		if not P_IsObjectOnGround(playerMo) then
			if player.pflags & L_PF_APPLYAUTOBRAKE then
				playerMo.momx = L_FixedMul($, AIR_FRICTION_AUTOBRAKE)
				playerMo.momy = L_FixedMul($, AIR_FRICTION_AUTOBRAKE)
			else
				playerMo.momx = L_FixedMul($, AIR_FRICTION)
				playerMo.momy = L_FixedMul($, AIR_FRICTION)
			end
			playerMo.momz = L_FixedMul($, AIR_FRICTION)
			if abs(playerMo.momx) < STOP_MOMENTUM then playerMo.momx = 0 end
			if abs(playerMo.momy) < STOP_MOMENTUM then playerMo.momy = 0 end
			if abs(playerMo.momz) < STOP_MOMENTUM then playerMo.momz = 0 end
		end

		if P_IsObjectOnGround(playerMo) then
			if (cmd.forwardmove ~= 0 or cmd.sidemove ~= 0) then
				P_SetObjectMomZ(playerMo, FRACUNIT*2)
			end
			CheckAndCrumble2(playerMo,playerMo.subsector.sector)
		end
	end

	local tracer = playerMo.tracer
	if player.powers[l_pw_carry] == 0 then

		if player.pixieHoming > 0 and not P_PlayerInPain(player) then

			-- Stop homing if player isn't moving
			if L_FixedHypot(L_FixedHypot(player.mo.momx, player.mo.momy), player.mo.momz) < FRACUNIT * 20 then
				StopHoming(player)
			elseif IsValid(tracer) and not P_HomingAttack(playerMo, tracer) then
				StopHoming(player)
			else
				player.drawangle = playerMo.angle
				P_InstaThrust(playerMo, playerMo.angle, DASH_SPEED)
			end
			P_SpawnGhostMobj(playerMo)
			player.pixieHoming = $ - 1
			if player.pixieHoming == 0 then
				StopHoming(player)
			end
		else
			local enemy = P_LookForEnemies(player, false, true)
			if IsValid(enemy) then
				P_SpawnLockOn(player, enemy, L_S_LOCKON1)
			end
			if player.pixieHoming < 0 then
				player.pixieHoming = $ + 1
			end
		end

		local playerMoState = playerMo.state
		if playerMoState == L_S_PLAY_WAIT or playerMoState == L_S_PLAY_FALL or playerMoState == L_S_PLAY_SPRING or playerMoState == L_S_PLAY_RUN then
			playerMo.state = L_S_PLAY_WALK
		end
		if player.speed < FRACUNIT then
			if playerMo.state == L_S_PLAY_WALK then
				playerMo.state = L_S_PLAY_STND
			end
		else
			if playerMo.state == L_S_PLAY_STND and player.pixieFollow then
				playerMo.state = L_S_PLAY_WALK
			end
		end

	end

end

function Character.CarryStart(player, carry_type)
	player.pixieHoming = 0
	player.pflags = $ & ~L_PF_DRILLING
end

function Character.CarryEnd(player)
	local playerMo = player.mo
	if playerMo.state == L_S_PLAY_ROLL then
		playerMo.state = L_S_PLAY_WALK
		player.pflags = $ & ~PF_SPINNING
	end
end

function Character.CanDamage(player)
	local playerMo = player.mo
	if player.pixieHoming ~= 0 then
		return true
	end
end

function Character.JumpButton(player, state)
	if (player.powers[l_pw_nocontrol] ~= 0 and player.powers[l_pw_nocontrol] < 32768)
	or state ~= CharacterManager2.STATE_PRESSED then
		return
	end
	local playerMo = player.mo
	StopFollowing(player)
	if IsValid(playerMo) and P_IsObjectOnGround(playerMo) then
		playerMo.state = L_S_PLAY_WALK
		return true
	end
end

function Character.SpinButton(player, state)
	if player.powers[l_pw_nocontrol] ~= 0
	or state ~= CharacterManager2.STATE_PRESSED then
		return
	end
	StopFollowing(player)
end

-- Homing attack button
function Character.Custom1(player, state)
	if player.exiting ~= 0
	or player.playerstate == L_PST_DEAD
	or player.powers[l_pw_carry] ~= 0
	or player.powers[l_pw_nocontrol] ~= 0
	or P_PlayerInPain(player)
	or player.pixieHoming ~= 0
	or state ~= CharacterManager2.STATE_PRESSED then
		return
	end
	local playerMo = player.mo
	if not IsValid(playerMo) or P_IsObjectOnGround(playerMo) then return end
	StopFollowing(player)

	local enemy = P_LookForEnemies(player, false, true)
	if IsValid(enemy) and P_HomingAttack(playerMo, enemy) then
		player.pixieHoming = TICRATE * 3
		playerMo.tracer = enemy
	else
		player.pixieHoming = TICRATE/2
		P_InstaThrust(playerMo, playerMo.angle, DASH_SPEED)
	end
	player.pflags = $ | L_PF_DRILLING
end

-- Follow button
function Character.Custom2(player, state)
	if player.exiting ~= 0
	or player.playerstate == L_PST_DEAD
	or player.powers[l_pw_nocontrol] ~= 0
	or P_PlayerInPain(player)
	or player.pixieHoming > 0
	or state ~= CharacterManager2.STATE_PRESSED then
		return
	end
	if player.pixieFollow then
		StopFollowing(player)
		return
	end
	local carry = player.powers[l_pw_carry]
	local partner = player.pixiePartner
	if carry == L_CR_MINECART or carry == L_CR_ROLLOUT or P_PlayerInPain(player) or not IsValid(partner) or partner.playerstate & L_PST_DEAD > 0 then
		S_StartSound(nil, SOUND_NO_GOOD, player)
		return
	end
	local playerMo = player.mo
	if not IsValid(playerMo) then return end
	local partnerMo = partner.mo
	if not IsValid(partnerMo) then return end
	--TODO: Fix minecarts and rollout rocks
	playerMo.tracer = nil
	player.powers[l_pw_carry] = 0
	player.pixieHoming = 0
	player.pixieGiveCooldown = GIVE_COOLDOWN
	player.pixieFollow = true
end

-- Partner select button
function Character.Custom3(player, state)
	if player.exiting ~= 0
	or player.playerstate == L_PST_DEAD
	or player.powers[l_pw_nocontrol] ~= 0
	or state ~= CharacterManager2.STATE_PRESSED then
		return
	end

	-- Pick partner player
	local playerMo = player.mo
	if not IsValid(playerMo) then return end
	local playerX = playerMo.x
	local playerY = playerMo.y

	local closestPlayer, closestDist

	for p in players.iterate do
		if not IsValid(p) or p == player then continue end
		local toucherMo = p.mo
		if not IsValid(toucherMo) or toucherMo.skin == "pixie" then continue end
		local dist = L_FixedHypot(playerX - toucherMo.x, playerY - toucherMo.y)
		if closestDist == nil or dist < closestDist then
			closestDist = dist
			closestPlayer = p
		end
	end

	if closestPlayer and closestDist and closestDist < DIST_PARTNER_SELECT
	and SetPartner(player, closestPlayer) then
		S_StartSound(nil, SOUND_SUCCESS, player)
		CONS_Printf(player, "Set Partner: "..closestPlayer.name)
	else
		S_StartSound(nil, SOUND_NO_GOOD, player)
		CONS_Printf(player, "Failed to set partner")
	end
end

function Character.ShouldTakeDamage(player, playerMo, inflictor, source, damage, damagetype)
	if player.pixieFollow and damagetype & DMG_DEATHMASK == 0 then
		return false
	end
	StopFollowing(player)
end

function Character.BotTiccmd(player, cmd)
	local time = leveltime
	if player.pixiePartnerNum == nil and time % 2 then
		cmd.buttons = $ | BT_CUSTOM3
	elseif player.pixieFollow ~= true and time % 2 then
		cmd.buttons = $ | BT_CUSTOM2
	end
	return true
end

CharacterManager2.Register(Character)

local function BounceTouch(sepcial, toucher)
	if toucher.skin ~= "pixie" then return end
	toucher.player.pixieHoming = -HOMING_INVULN
end

local function DeathDisconnect(target)
	local player = target.player
	if IsValid(target.player) and player.pixieFollowers then
		for _, pixie in pairs(player.pixieFollowers) do
			if IsValid(pixie) and pixie.pixieFollow then
				pixie.powers[pw_flashing] = TICRATE
				StopFollowing(pixie)
			end
		end
	end
end

local function QuitUnpartner(player)
	if player.realmo.skin ~= "pixie" then return end
	RemovePartner(player)
end

addHook("TouchSpecial", BounceTouch, MT_FAKEMOBILE)
addHook("TouchSpecial", BounceTouch, MT_EGGSHIELD)
addHook("MobjDeath", DeathDisconnect, MT_PLAYER)
addHook("PlayerQuit", QuitUnpartner)

local HUD_CENTER = 160
local ICON_Y = 188
local HUD_SIDE_PADDING = 28
local HUD_PARTNER_Y = 184
local HUD_PARTNER_X = 100

hud.add(function(v, player)
	if player.realmo.skin == "pixie" then
		local partner = player.pixiePartner
		local ringtrans = player.rings < 10 and L_V_HUDTRANSHALF or 0
		local powertrans = nil
		local monitorpatch = nil
		if player.pixiePowerup ~= nil then
			monitorpatch = v.getSpritePatch(states[mobjinfo[player.pixiePowerup].spawnstate].sprite, 2)
			powertrans = 0
		else
			monitorpatch = v.getSpritePatch(SPR_TV1P, 2)
			powertrans = L_V_HUDTRANSHALF
		end
		if player.pixieFollow then
			v.draw(HUD_CENTER - 32, ICON_Y, v.getSpritePatch(SPR_TVRI, 2), L_V_SNAPTOBOTTOM | L_V_PERPLAYER | ringtrans)
			v.draw(HUD_CENTER + 32, ICON_Y, monitorpatch, L_V_SNAPTOBOTTOM | L_V_PERPLAYER | powertrans)
			v.drawString(HUD_CENTER, ICON_Y - 12, CHAR_LEFT_ARROW..""..CHAR_RIGHT_ARROW, L_V_SNAPTOBOTTOM | L_V_PERPLAYER | L_V_YELLOWMAP| L_V_HUDTRANS, "center")
		else
			v.draw(320 - HUD_SIDE_PADDING, ICON_Y, monitorpatch, L_V_SNAPTOBOTTOM | L_V_SNAPTORIGHT | L_V_PERPLAYER | powertrans)
		end
		if IsValid(partner) and not G_IsSpecialStage() then
			local partnerRealMo = partner.realmo
			local skin = partner.skin
			local patch = v.getSprite2Patch(skin, "XTRA", partner.powers[l_pw_super] > 0)
			v.drawScaled((HUD_PARTNER_X - 12) * FRACUNIT, (HUD_PARTNER_Y - 8) * FRACUNIT, FRACUNIT / 2, patch , L_V_SNAPTOBOTTOM | L_V_SNAPTOLEFT | L_V_PERPLAYER | L_V_HUDTRANS, v.getColormap(skin, partnerRealMo.color))
			v.drawScaled((HUD_PARTNER_X + 4) * FRACUNIT, (HUD_PARTNER_Y + 8) * FRACUNIT, FRACUNIT / 2, v.getSpritePatch(SPR_TVRI, 2), L_V_SNAPTOBOTTOM | L_V_SNAPTOLEFT | L_V_PERPLAYER | L_V_HUDTRANS)
			v.drawString(HUD_PARTNER_X + 16, HUD_PARTNER_Y, tostring(partner.rings), L_V_SNAPTOBOTTOM | L_V_SNAPTOLEFT | L_V_PERPLAYER | L_V_HUDTRANS)
		end
	end
end, "game")

-- Pixie code by j2b2